from http.server import HTTPServer, BaseHTTPRequestHandler
from urllib.parse import urlparse, parse_qs

class MyHandler(BaseHTTPRequestHandler):
    def do_GET(self):
        self._set_headers()
        length = int(self.headers.getheader('content-length'))
        field_data = self.rfile.read(length)
        fields = parse_qs(field_data)
        self.wfile.write("<html><body><h1>hi!</h1></body></html>")

def run(server_class=HTTPServer, handler_class=BaseHTTPRequestHandler):
    server_address = ('', 8000)
    httpd = server_class(server_address, handler_class)

    httpd.serve_forever()

    httpd.get_request()

if __name__=="__main__":
    run(handler_class=MyHandler)

